Package tigase.xmpp.impl

## Class EntityTime

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.XMPPProcessorAbstract
      - - tigase.xmpp.impl.EntityTime

- All Implemented Interfaces:
    `java.lang.Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

      @Bean(name="urn:xmpp:time",
            parent=SessionManager.class,
            active=true)
      public class EntityTime
      extends XMPPProcessorAbstract

  This supports the implementation of XEP-0202: Entity Time.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected static java.lang.String` | `ID` |
    `protected static java.lang.String` | `TIME` |
    `protected static java.lang.String` | `XMLNS` |

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EntityTime()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `id()` | Method `id` returns a unique ID of the plugin.
    `void` | `processFromUserOutPacket​(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet is sent from the user, owner of the session somewhere else to other XMPP entity (other user on the server, other user on a different server, different server, component, transport, etc....).
    `void` | `processFromUserToServerPacket​(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...).
    `void` | `processNullSessionPacket​(Packet packet, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called for packets received by the server for which no user session is found - neither sender session or receiver session.
    `void` | `processServerSessionPacket​(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet addressed to the server domain is received.
    `void` | `processToUserPacket​(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | Method is called for all the packets sent TO the user - owner of the session.

    - ### Methods inherited from class tigase.xmpp.XMPPProcessorAbstract

      `isFromUserSession, isNullSession, isServerSession, isToUserSession, process, processFromUserPacket`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

- - ### Field Detail

    - #### XMLNS

          protected static final java.lang.String XMLNS

      See Also:
        Constant Field Values

    - #### TIME

          protected static final java.lang.String TIME

      See Also:
        Constant Field Values

    - #### ID

          protected static final java.lang.String ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EntityTime

          public EntityTime()

  - ### Method Detail

    - #### id

          public java.lang.String id()

      Description copied from interface: `XMPPImplIfc`
      Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
      Specified by:
        `id` in interface `XMPPImplIfc`
      Overrides:
        `id` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String` value

    - #### processFromUserOutPacket

          public void processFromUserOutPacket​(JID connectionId,
                                               Packet packet,
                                               XMPPResourceConnection session,
                                               NonAuthUserRepository repo,
                                               java.util.Queue<Packet> results,
                                               java.util.Map<java.lang.String,​java.lang.Object> settings)
                                        throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet is sent from the user, owner of the session somewhere else to other XMPP entity (other user on the server, other user on a different server, different server, component, transport, etc....). The default implementation just forwards the packet doing nothing else, which is good enough in most cases. You can overwrite the method to change the default behaviour.
      Overrides:
        `processFromUserOutPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processFromUserToServerPacket

          public void processFromUserToServerPacket​(JID connectionId,
                                                    Packet packet,
                                                    XMPPResourceConnection session,
                                                    NonAuthUserRepository repo,
                                                    java.util.Queue<Packet> results,
                                                    java.util.Map<java.lang.String,​java.lang.Object> settings)
                                             throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...). There is no default implementation for the method.
      Specified by:
        `processFromUserToServerPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processNullSessionPacket

          public void processNullSessionPacket​(Packet packet,
                                               NonAuthUserRepository repo,
                                               java.util.Queue<Packet> results,
                                               java.util.Map<java.lang.String,​java.lang.Object> settings)
                                        throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called for packets received by the server for which no user session is found - neither sender session or receiver session. The default implementation does nothing, just ignores such a packet. To change the default behaviour the method has to be overwritten.
      Overrides:
        `processNullSessionPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processServerSessionPacket

          public void processServerSessionPacket​(Packet packet,
                                                 XMPPResourceConnection session,
                                                 NonAuthUserRepository repo,
                                                 java.util.Queue<Packet> results,
                                                 java.util.Map<java.lang.String,​java.lang.Object> settings)
                                          throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet addressed to the server domain is received. Please note, if a local user sends a packet to the server, the packet is handled by the `processFromUserPacket(...)` method. This method is not called for such packets.
      Specified by:
        `processServerSessionPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
        `session` - is a `XMPPResourceConnection` instance with all the server session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processToUserPacket

          public void processToUserPacket​(Packet packet,
                                          XMPPResourceConnection session,
                                          NonAuthUserRepository repo,
                                          java.util.Queue<Packet> results,
                                          java.util.Map<java.lang.String,​java.lang.Object> settings)
                                   throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      Method is called for all the packets sent TO the user - owner of the session. The default implementation just forwards the packet to the user connection. To change the default behavior the method has to be overwritten.
      Overrides:
        `processToUserPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
        `session` - is a `XMPPResourceConnection` instance with all the receiving user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.